<%
'(C) Copyright 2001 by UltraApps
'View files/license.html for Legal Information
'-------------------------------
' IssuesList CustomIncludes begin
%>

<!-- #INCLUDE FILE="Common.asp" -->
<!-- #INCLUDE FILE="Header.asp" -->
<!-- #INCLUDE FILE="Footer.asp" -->

<%
' IssuesList CustomIncludes end
'-------------------------------

'===============================
' Save Page and File Name available into variables
'-------------------------------
sFileName = "IssuesList.asp"
sTemplateFileName = "IssuesList.html"
'===============================


'===============================
' IssuesList PageSecurity begin
CheckSecurity(3)
' IssuesList PageSecurity end
'===============================

'===============================
' IssuesList Open Event begin
' IssuesList Open Event end
'===============================

'===============================
' IssuesList OpenAnyPage Event begin
' IssuesList OpenAnyPage Event end
'===============================

'===============================
'Save the name of the form and type of action into the variables
'-------------------------------
sAction = GetParam("FormAction")
sForm = GetParam("FormName")
'===============================

' IssuesList Show begin

'===============================
' Display page
'-------------------------------
' Load HTML template for this page
'-------------------------------
LoadTemplate sAppPath & sTemplateFileName, "main"
'-------------------------------
' Load HTML template of Header and Footer
'-------------------------------
LoadTemplate sHeaderFileName, "Header"
LoadTemplate sFooterFileName, "Footer"
'-------------------------------
SetVar "FileName", sFileName


'-------------------------------
' Step through each form
'-------------------------------
Menu_Show
FooterForm_Show
Search_Show
Issues_Show
'-------------------------------
' Process page templates
'-------------------------------
Parse "Header", False
Parse "Footer", False
Parse "main", False
'-------------------------------
' Output the page to the browser
'-------------------------------
Response.write PrintVar("main")

' IssuesList Show end

'-------------------------------
' Destroy all object variables
'-------------------------------
cn.Close
Set cn = Nothing
UnloadTemplate
'===============================

'===============================
' IssuesList Close Event begin
' IssuesList Close Event end
'===============================

'===============================
' Display Grid Form
'-------------------------------
Sub Issues_Show()
'-------------------------------
' Initialize variables  
'-------------------------------
  Dim rs
  Dim sWhere : sWhere = ""
  Dim sOrder : sOrder = ""
  Dim sSQL : sSQL = ""
  Dim sFormTitle: sFormTitle = "Issues"
  Dim HasParam : HasParam = false
  Dim iSort : iSort = ""
  Dim iSorted : iSorted = ""
  Dim sDirection : sDirection = ""
  Dim sSortParams : sSortParams = ""
  Dim iRecordsPerPage : iRecordsPerPage = 20
  Dim iCounter : iCounter = 0
  Dim iPage : iPage = 0
  Dim bEof : bEof = False

  SetVar "TransitParams", "assigned_to=" & ToURL(GetParam("assigned_to")) & "&issue_name=" & ToURL(GetParam("issue_name")) & "&notstatus_id=" & ToURL(GetParam("notstatus_id")) & "&priority_id=" & ToURL(GetParam("priority_id")) & "&status_id=" & ToURL(GetParam("status_id")) & "&"
  SetVar "FormParams", "assigned_to=" & ToURL(GetParam("assigned_to")) & "&issue_name=" & ToURL(GetParam("issue_name")) & "&notstatus_id=" & ToURL(GetParam("notstatus_id")) & "&priority_id=" & ToURL(GetParam("priority_id")) & "&status_id=" & ToURL(GetParam("status_id")) & "&"

'-------------------------------
' Build WHERE statement
'-------------------------------
  passigned_to = GetParam("assigned_to")
  if IsNumeric(passigned_to) and not isEmpty(passigned_to) then passigned_to = ToSQL(passigned_to, "Number") else passigned_to = Empty
  if not isEmpty(passigned_to) then
    HasParam = true
    sWhere = sWhere & "i.[assigned_to]=" & passigned_to
  end if
  pissue_name = GetParam("issue_name")
  if not isEmpty(pissue_name) then
    if not (sWhere = "") then sWhere = sWhere & " and "
    HasParam = true
    sWhere = sWhere & "i.[issue_name] like '%" & replace(pissue_name, "'", "''") & "%'"
  end if
  pnotstatus_id = GetParam("notstatus_id")
  if IsNumeric(pnotstatus_id) and not isEmpty(pnotstatus_id) then pnotstatus_id = ToSQL(pnotstatus_id, "Number") else pnotstatus_id = Empty
  if not isEmpty(pnotstatus_id) then
    if not (sWhere = "") then sWhere = sWhere & " and "
    HasParam = true
    sWhere = sWhere & "i.[status_id]<>" & pnotstatus_id
  end if
  ppriority_id = GetParam("priority_id")
  if IsNumeric(ppriority_id) and not isEmpty(ppriority_id) then ppriority_id = ToSQL(ppriority_id, "Number") else ppriority_id = Empty
  if not isEmpty(ppriority_id) then
    if not (sWhere = "") then sWhere = sWhere & " and "
    HasParam = true
    sWhere = sWhere & "i.[priority_id]=" & ppriority_id
  end if
  pstatus_id = GetParam("status_id")
  if IsNumeric(pstatus_id) and not isEmpty(pstatus_id) then pstatus_id = ToSQL(pstatus_id, "Number") else pstatus_id = Empty
  if not isEmpty(pstatus_id) then
    if not (sWhere = "") then sWhere = sWhere & " and "
    HasParam = true
    sWhere = sWhere & "i.[status_id]=" & pstatus_id
  end if


  if HasParam then
    sWhere = " WHERE (" & sWhere & ")"
  end if
  
'-------------------------------
' Build ORDER BY statement
'-------------------------------
  iSort = GetParam("FormIssues_Sorting")
  iSorted = GetParam("FormIssues_Sorted")
  sDirection = ""
  if IsEmpty(iSort) then
    SetVar "Form_Sorting", ""
  else
    if iSort = iSorted then 
      SetVar "Form_Sorting", ""
      sDirection = " DESC"
      sSortParams = "FormIssues_Sorting=" & iSort & "&FormIssues_Sorted=" & iSort & "&"
    else
      SetVar "Form_Sorting", iSort
      sDirection = " ASC"
      sSortParams = "FormIssues_Sorting=" & iSort & "&FormIssues_Sorted=" & "&"
    end if
    if iSort = 1 then sOrder = " order by i.[issue_id]" & sDirection
    if iSort = 2 then sOrder = " order by i.[issue_name]" & sDirection
    if iSort = 3 then sOrder = " order by s.[status]" & sDirection
    if iSort = 4 then sOrder = " order by u.[user_name]" & sDirection
    if iSort = 5 then sOrder = " order by i.[date_submitted]" & sDirection
    if iSort = 6 then sOrder = " order by i.[date_modified]" & sDirection
    if iSort = 7 then sOrder = " order by i.[date_resolved]" & sDirection
  end if

'-------------------------------
' Build base SQL statement
'-------------------------------
  sSQL = "select [i].[assigned_to] as i_assigned_to, " & _
    "[i].[date_modified] as i_date_modified, " & _
    "[i].[date_resolved] as i_date_resolved, " & _
    "[i].[date_submitted] as i_date_submitted, " & _
    "[i].[issue_id] as i_issue_id, " & _
    "[i].[issue_name] as i_issue_name, " & _
    "[i].[priority_id] as i_priority_id, " & _
    "[i].[status_id] as i_status_id, " & _
    "[s].[status_id] as s_status_id, " & _
    "[s].[status] as s_status, " & _
    "[u].[user_id] as u_user_id, " & _
    "[u].[user_name] as u_user_name " & _
    " from (([issues] i left join [statuses] s on [s].[status_id]=i.[status_id]) inner join [users] u on [u].[user_id]=i.[assigned_to]) "
'-------------------------------

'-------------------------------
' Issues Open Event begin
' Issues Open Event end
'-------------------------------

'-------------------------------
' Assemble full SQL statement
'-------------------------------
  sSQL = sSQL & sWhere & sOrder
'-------------------------------

SetVar "FormTitle", sFormTitle

'-------------------------------
' Process the parameters for sorting
'-------------------------------
  SetVar "SortParams", sSortParams
'-------------------------------

'-------------------------------
' Open the recordset
'-------------------------------
  openrs rs, sSQL
'-------------------------------

'-------------------------------
' Process empty recordset
'-------------------------------
  if rs.eof then
    set rs = nothing
    SetVar "DListIssues", ""
    Parse "IssuesNoRecords", False
    SetVar "IssuesNavigator", ""
    Parse "FormIssues", False
    exit sub
  end if
'-------------------------------

'-------------------------------
' Initialize page counter and records per page
'-------------------------------
  iRecordsPerPage = 20
  iCounter = 0
'-------------------------------

'-------------------------------
' Process page scroller
'-------------------------------
  iPage = GetParam("FormIssues_Page")
  if IsEmpty(iPage) then iPage = 1 else iPage = CLng(iPage)
  while not rs.eof and iCounter < (iPage-1)*iRecordsPerPage
    rs.movenext
    iCounter = iCounter + 1
  wend
  iCounter = 0
'-------------------------------

'-------------------------------
' Display grid based on recordset
'-------------------------------
  while not rs.EOF  and iCounter < iRecordsPerPage
'-------------------------------
' Create field variables based on database fields
'-------------------------------
    fldassigned_to = GetValue(rs, "u_user_name")
    flddate_modified = GetValue(rs, "i_date_modified")
    flddate_resolved = GetValue(rs, "i_date_resolved")
    flddate_submitted = GetValue(rs, "i_date_submitted")
    fldissue_id = GetValue(rs, "i_issue_id")
    fldissue_name_URLLink = "IssuesMaint.asp"
    fldissue_name_issue_id = GetValue(rs, "i_issue_id")
    fldissue_name = GetValue(rs, "i_issue_name")
    fldstatus_id = GetValue(rs, "s_status")
'-------------------------------
' Issues Show begin
'-------------------------------

'-------------------------------
' Issues Show Event begin
' Issues Show Event end
'-------------------------------

'-------------------------------
' Replace Template fields with database values
'-------------------------------
    
      SetVar "issue_id", ToHTML(fldissue_id)
      SetVar "issue_name", ToHTML(fldissue_name)
      SetVar "issue_name_URLLink", fldissue_name_URLLink
      SetVar "Prmissue_name_issue_id", ToURL(fldissue_name_issue_id)
      SetVar "status_id", ToHTML(fldstatus_id)
      SetVar "assigned_to", ToHTML(fldassigned_to)
      SetVar "date_submitted", ToHTML(flddate_submitted)
      SetVar "date_modified", ToHTML(flddate_modified)
      SetVar "date_resolved", ToHTML(flddate_resolved)
    Parse "DListIssues", True

'-------------------------------
' Issues Show end
'-------------------------------

'-------------------------------
' Move to the next record and increase record counter
'-------------------------------
    rs.MoveNext
    iCounter = iCounter + 1
  wend
'-------------------------------


'-------------------------------
' Issues Navigation begin
'-------------------------------
  bEof = rs.eof
  if rs.eof and iPage = 1 then
	SetVar "IssuesNavigator", ""
  else
    if bEof then
      SetVar "IssuesNavigatorLastPage", "_"
    else
      SetVar "NextPage", (iPage + 1)
    end if
    if iPage = 1 then
      SetVar "IssuesNavigatorFirstPage", "_"
    else
      SetVar "PrevPage", (iPage - 1)
    end if
    SetVar "IssuesCurrentPage", iPage
    Parse "IssuesNavigator", False
  end if
'-------------------------------
' Issues Navigation end
'-------------------------------

'-------------------------------
' Finish form processing
'-------------------------------
  set rs = nothing
  SetVar "IssuesNoRecords", ""
  Parse "FormIssues", False

'-------------------------------
' Issues Close Event begin
' Issues Close Event end
'-------------------------------
End Sub
'===============================


'===============================
' Display Search Form
'-------------------------------
Sub Search_Show()
  Dim sFormTitle: sFormTitle = "Search"
  Dim sActionFileName: sActionFileName = "IssuesList.asp"
'-------------------------------
' Search Open Event begin
' Search Open Event end
'-------------------------------
      SetVar "FormTitle", sFormTitle
      SetVar "ActionPage", sActionFileName

'-------------------------------
' Set variables with search parameters
'-------------------------------
      fldissue_name = GetParam("issue_name")
      fldpriority_id = GetParam("priority_id")
      fldstatus_id = GetParam("status_id")
      fldnotstatus_id = GetParam("notstatus_id")
      fldassigned_to = GetParam("assigned_to")

'-------------------------------
' Search Show begin
'-------------------------------


'-------------------------------
' Search Show Event begin
' Search Show Event end
'-------------------------------
      SetVar "issue_name", ToHTML(fldissue_name)
      SetVar "SearchLBpriority_id", ""
      SetVar "Selected", ""
      SetVar "ID", ""
      SetVar "Value", "All"
      Parse "SearchLBpriority_id", True
      openrs rspriority_id, "select priority_id, priority_desc from priorities order by 2"
      while not rspriority_id.EOF
        SetVar "ID", GetValue(rspriority_id, 0) : SetVar "Value", GetValue(rspriority_id, 1)
        if cstr(GetValue(rspriority_id, 0)) = cstr(fldpriority_id) then SetVar "Selected", "SELECTED" else SetVar "Selected", ""
        Parse "SearchLBpriority_id", True
        rspriority_id.MoveNext
      wend
      set rspriority_id = nothing
    
      SetVar "SearchLBstatus_id", ""
      SetVar "Selected", ""
      SetVar "ID", ""
      SetVar "Value", "All"
      Parse "SearchLBstatus_id", True
      openrs rsstatus_id, "select status_id, status from statuses order by 2"
      while not rsstatus_id.EOF
        SetVar "ID", GetValue(rsstatus_id, 0) : SetVar "Value", GetValue(rsstatus_id, 1)
        if cstr(GetValue(rsstatus_id, 0)) = cstr(fldstatus_id) then SetVar "Selected", "SELECTED" else SetVar "Selected", ""
        Parse "SearchLBstatus_id", True
        rsstatus_id.MoveNext
      wend
      set rsstatus_id = nothing
    
      SetVar "SearchLBnotstatus_id", ""
      SetVar "Selected", ""
      SetVar "ID", "0"
      SetVar "Value", "(Show All)"
      Parse "SearchLBnotstatus_id", True
      openrs rsnotstatus_id, "select status_id, status from statuses order by 2"
      while not rsnotstatus_id.EOF
        SetVar "ID", GetValue(rsnotstatus_id, 0) : SetVar "Value", GetValue(rsnotstatus_id, 1)
        if cstr(GetValue(rsnotstatus_id, 0)) = cstr(fldnotstatus_id) then SetVar "Selected", "SELECTED" else SetVar "Selected", ""
        Parse "SearchLBnotstatus_id", True
        rsnotstatus_id.MoveNext
      wend
      set rsnotstatus_id = nothing
    
      SetVar "SearchLBassigned_to", ""
      SetVar "Selected", ""
      SetVar "ID", ""
      SetVar "Value", "Anyone"
      Parse "SearchLBassigned_to", True
      openrs rsassigned_to, "select user_id, user_name from users order by 2"
      while not rsassigned_to.EOF
        SetVar "ID", GetValue(rsassigned_to, 0) : SetVar "Value", GetValue(rsassigned_to, 1)
        if cstr(GetValue(rsassigned_to, 0)) = cstr(fldassigned_to) then SetVar "Selected", "SELECTED" else SetVar "Selected", ""
        Parse "SearchLBassigned_to", True
        rsassigned_to.MoveNext
      wend
      set rsassigned_to = nothing
    

'-------------------------------
' Search Show end
'-------------------------------

'-------------------------------
' Search Close Event begin
' Search Close Event end
'-------------------------------
      Parse "FormSearch", False
End Sub
'===============================

%>